/* eslint-disable */
<template>
  <v-container>
    <v-card>
      <v-data-table
        :show-select="userCanDelete"
        v-model="selectedUsers"
        :page.sync="pagination.page"
        :headers="headers"
        :items="users"
        :items-per-page="numberPerPage"
        hide-default-footer
        class="elevation-1"
        :footer-props="{
          itemsPerPageText: 'Usuários por página',
        }"
      >
        <template v-slot:top>
            <div class="toolBar">
            <v-toolbar-title class="font-weight-bold primary--text">Usuários</v-toolbar-title>
            <div class="navUsersOption">
              <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
              <v-btn
                v-if="userCanCreate || userCanAddUserInEntity"
                small
                color="primary"
                class="mr-4"
                elevation="0"
                @click="handleCreate"
              >
                Adicionar
                <v-icon small right class="ml-3">mdi-plus</v-icon>
              </v-btn>
              <v-btn
                v-if="userCanImport"
                small
                color="primary"
                class="mr-4"
                elevation="0"
                @click="handleImport"
              >
                Importar
                <v-icon small right class="ml-3">mdi-file-import</v-icon>
              </v-btn>
            </div>
            <v-row no-gutters class="justify-end align-center fill-height wrap">
              <v-col align="center" cols="3">
                <v-select
                  v-model="filterType"
                  single-line
                  hide-details
                  :items="filterTypes"
                  item-text="label"
                  item-value="value"
                  class="mr-3"
                  style="max-width: 75%"
                ></v-select>
              </v-col>
              <v-col cols="5">
                <v-text-field
                  v-model="filterText"
                  label="Buscar"
                  single-line
                  hide-details
                ></v-text-field>
              </v-col>
              <v-col align="center" cols="1">
                <v-tooltip color="primary" bottom>
                  <template v-slot:activator="{ on }">
                    <v-btn
                      :disabled="filterText === ''"
                      slot="activator"
                      :style="filterType === 'none' && 'pointer-events: none'"
                      fab
                      x-small
                      :color="filterType === 'none' ? 'secondary' : 'primary'"
                      v-on="on"
                      @click="handleFilter"
                    >
                      <v-icon small>mdi-magnify</v-icon>
                    </v-btn>
                  </template>
                  <span>Buscar</span>
                </v-tooltip>
              </v-col>
              <v-col class="pa-0 ml-n2" cols="1" align="start">
                <v-tooltip color="red" bottom>
                  <template v-slot:activator="{ on }">
                    <v-icon
                      :disabled="filterType === 'none'"
                      class="ml-2"
                      @click="refresh"
                      v-on="on"
                      color="red"
                      >mdi-magnify-minus-outline</v-icon
                    >
                  </template>
                  <span>Remover resultado busca</span>
                </v-tooltip>
              </v-col>
            </v-row>
          </div>
          <div
            v-if="haveChild && userCanEdit"
            style="font-size: 0.85rem;"
            class="ml-4 my-2 secondary--text"
          >
            <v-icon small class="pb-1 mr-1">mdi-alert</v-icon> Exibindo usuários da
            <b>própria entidade</b> e das entidades <b>parentes inferiores</b> ao nível hierárquico
            de <b>({{ nameOfEntity }})</b>.
          </div>
        </template>
        <template v-slot:[`item.name`]="{ item }">
          <span v-if="item.id == loggedUserid"
            ><b>{{ item.name }} {{ item.surname }}</b></span
          >
          <span v-else>{{ item.name }} {{ item.surname }}</span>
        </template>

        <template v-slot:[`item.actions`]="{ item }">
          <div class="usersTable">
            <v-tooltip bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small>mdi-email</v-icon>
              </template>
              <span>Enviar mensagem</span>
            </v-tooltip>
            <v-tooltip v-if="userCanEdit" bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small @click="handleEdit(item)">mdi-pencil</v-icon>
              </template>
              <span v-if="item.id == loggedUserid"><b>Editar</b> seus dados</span>
              <span v-else><b>Editar</b> usuário</span>
            </v-tooltip>
            <v-tooltip v-if="userCanChangePrivilege" bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small @click="handleManage(item)">mdi-cog</v-icon>
              </template>
              <span v-if="item.id == loggedUserid"><b>Gerenciar</b> suas entidades</span>
              <span v-else><b>Gerenciar</b> entidades do usuário</span>
            </v-tooltip>
            <v-tooltip v-if="userCanDelete" bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small @click="handleDelete(item)">mdi-delete</v-icon>
              </template>
              <span>Remover usuário</span>
            </v-tooltip>
          </div>
        </template>
      </v-data-table>
      <v-pagination
        v-model="pagination.page"
        class="py-2"
        :length="pages"
        @input="changePage"
      ></v-pagination>
    </v-card>
    <UsersCreate v-if="userCanCreate || userCanAddUserInEntity" />
    <UsersUpdate @updateUser="refreshAfterUpdateUser" />
    <UsersManage v-if="userCanEdit" :user="userToEdit" @updatedHimself="updatedHimself" />
    <UsersImport ref="usersImport" @usersImportedDone="refreshAfterUpdateUser" />
    <v-dialog v-model="userChangeRoleDialog" width="500px">
      <UserChangeRole
        :user="userToEdit"
        :actualRole="roleInActualEntity"
        :availableRoles="availableRolesToChange"
        :changeRoleDenied="changeRoleDenied"
        :userNotFound="userNotFound"
        :nameOfEntity="fatherEntity"
        @closeUserChangeRole="userChangeRoleDialog = false"
        @userChangeRoleDone="userChangeRoleDone"
        @userChangeRoleFailed="userChangeRoleFailed"
        @updatedHimself="updatedHimself"
      />
    </v-dialog>
    <!-- Confirma deletar usuario -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDelete"
    />
    <!-- Confirma remover usuário da entidade -->
    <AlertConfirm
      :alert="alert2"
      @clickCancelAlert="alert2.status = false"
      @clickConfirmAlert="confirmRemoveFromEntity"
    />
    <!-- Snackbar -->
    <v-snackbar v-model="snackbar" color="white" :timeout="-1" class="pa-1" right>
      <v-row no-gutters justify="end" class="mb-n1">
        <v-icon @click="handleSnackClose" color="primary" small>mdi-close</v-icon>
      </v-row>
      <v-row class="mb-4 mt-1 primary--text" no-gutters justify="center">
        <v-icon class="mt-n1 mr-2" color="primary">{{
          idSelectedUsers.length > 1 ? 'mdi-account-group' : 'mdi-account'
        }}</v-icon>
        {{
          idSelectedUsers.length > 1
            ? `${idSelectedUsers.length} usuários selecionados.`
            : `1 usuário selecionado.`
        }}
      </v-row>
      <v-row justify="center" no-gutters>
        <v-btn small outlined class="pa-3 mr-2" @click="handleSnackChangeRoles" color="primary">
          {{ idSelectedUsers.length > 1 ? 'Alterar Papéis' : 'Alterar Papel' }}
        </v-btn>
        <v-btn small outlined class="pa-3" color="primary" @click="handleSnackDeleteUsers">
          Deletar
        </v-btn>
      </v-row>
    </v-snackbar>
  </v-container>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import Management from '../../services/management'
import UsersImport from '../../components/management/UsersImport'
import UsersCreate from '../../components/management/UsersCreate'
import UsersUpdate from '../../components/management/UsersUpdate'
import UsersManage from '../../components/management/UsersManage'
import UserChangeRole from '../../components/management/UsersChangeRole'
import User from '../../services/user'
import { Utils } from '../../utils/utils'

export default {
  name: 'Users',
  components: {
    UsersCreate,
    UsersUpdate,
    UsersImport,
    UsersManage,
    UserChangeRole,
  },
  data: () => ({
    fatherEntity: '',
    userChangeRoleDialog: false,
    roleInActualEntity: {},
    availableRolesToChange: [],
    changeRoleDenied: false,
    userNotFound: false,
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert2: {
      icon: 'mdi-account-remove',
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    selectedUsers: [],
    headers: [
      { text: 'Nome', align: 'center', sortable: false, value: 'name' },
      { text: 'Papel', align: 'center', sortable: false, value: 'role' },
      { text: 'Data de nascimento', align: 'center', sortable: false, value: 'birthday' },
      { text: 'Email', align: 'center', sortable: false, value: 'email' },
      { text: 'Matrícula', align: 'center', sortable: false, value: 'matriculation' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions' },
    ],
    headers2: [
      { text: 'Nome', align: 'center', sortable: false, value: 'name' },
      { text: 'Papel', align: 'center', sortable: false, value: 'role' },
      { text: 'Matrícula', align: 'center', sortable: false, value: 'matriculation' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions' },
    ],
    users: [],
    loggedUserid: '',
    userToEdit: {},
    pagination: {
      page: 1,
      totalItems: 0,
    },
    numberPerPage: 50,
    search: false,
    filterText: '',
    filterType: 'name',
    filterTypes: [
      { label: 'Nome', value: 'name' },
      { label: 'Documento', value: 'document' },
      { label: 'Matrícula', value: 'matriculation' },
    ],
    roles: [],
    color: 'green',
    userCanEdit: false,
    userCanChangeRole: false,
    userCanChangePrivilege: false,
    userCanDelete: false,
    userCanDeleteFromEntity: false,
    userCanCreate: false,
    userCanAddUserInEntity: false,
    userCanImport: false,
    haveChild: false,
    idEntity: '',
    snackbar: false,
  }),
  computed: {
    pages() {
      return Math.ceil(this.pagination.totalItems / this.numberPerPage)
    },
    nameOfEntity() {
      return this.$route.params.entityName
    },
    idSelectedUsers() {
      return this.selectedUsers.map((item) => {
        return item.id
      })
    },
  },
  watch: {
    idSelectedUsers() {
      if (this.idSelectedUsers.length >= 1) this.snackbar = true
      else this.snackbar = false
    },
  },
  beforeUpdate() {
    if (
      !this.userCanEdit &&
      !this.userCanDelete &&
      !this.userCanChangePrivilege &&
      !this.userCanChangeRole
    )
      this.headers = this.headers2
  },
  async created() {
    const routedEntity = await this.$getItem('routedEntity')
    this.idEntity = routedEntity.id
    await this.userCheckPrivileges('userCanEdit', 'userUpdate')
    await this.userCheckPrivileges('userCanChangeRole', 'userChangePrivilege')
    await this.userCheckPrivileges('userCanChangePrivilege', 'userRemove')
    await this.userCheckPrivileges('userCanDelete', 'userRemove')
    await this.userCheckPrivileges('userCanDeleteFromEntity', 'userRemoveFromEntity')
    await this.userCheckPrivileges('userCanCreate', 'userCreate')
    await this.userCheckPrivileges('userCanAddUserInEntity', 'userAddOnEntity')
    await this.userCheckPrivileges('userCanImport', 'usersImport')
    await this.readUsers()
    await this.checkHaveChild()
    await this.checkUIname()
  },
  methods: {
    ...mapMutations('user', [
      'UPDATE_USERS_CREATE',
      'UPDATE_USERS_UPDATE',
      'UPDATE_USERS_DELETE',
      'UPDATE_USERS_MANAGE',
    ]),

    refresh() {
      this.pagination.page = 1
      this.filterType = 'name'
      this.filterText = ''
      this.search = false
      this.readUsers()
    },
    refreshAfterUpdateUser() {
      this.readUsers()
    },

    changePage() {
      if (!this.search) {
        this.readUsers()
      }
    },

    handleSnackDeleteUsers() {
      if (this.idSelectedUsers.length == 1) {
        this.handleDelete(this.selectedUsers[0])
        this.snackbar = false
      } else {
        this.confirmDelete()
      }
    },

    handleSnackClose() {
      this.snackbar = false
    },

    async readUsers() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id
      const search = {
        entityId,
        page: this.pagination.page,
        skip: this.numberPerPage,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readUsersByPage(entityId, actionId, search)
        if (ret.success) {
          //filtrar só usuarios da entidade - não se aplica para quem tem permissão para ver tudo
          let usersFilter = ret.data.users.filter((user) => {
            let check = false
            user.entities.forEach((entity) => {
              if (entity.entity == entityId) check = true
            })
            if (check) return user
          })

          // condição de visão de usuários
          if (actionsMap.get('userUpdate')) {
            this.users = [
              ...ret.data.users.map((v) => {
                if (v.birthday !== undefined) v.birthday = Utils.timeConverter(v.birthday)
                return v
              }),
            ]
          } else {
            this.users = [
              ...usersFilter.map((user) => {
                if (user.birthday !== undefined) user.birthday = Utils.timeConverter(user.birthday)
                return user
              }),
            ]
            console.log(usersFilter, 'mostrandooooooo')
          }

          this.users.forEach((user) => {
            let role
            let count = 0
            user.entities.forEach((entity) => {
              if (entity.entity == entityId) {
                role = entity.privileges.label
                user.role = role
              } else count++
              if (count == user.entities.length) user.role = '---'
            })
          })

          this.users.sort((a, b) => {
            if (a.role > b.role) return -1
            if (a.role < b.role) return 1
            return 0
          })

          this.pagination.totalItems = ret.data.count
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    handleCreate() {
      this.UPDATE_USERS_CREATE(true)
    },

    async checkUIname() {
      const userInfo = await this.$getItem('userInfo')
      let id = userInfo.id
      this.loggedUserid = id
    },

    async checkHaveChild() {
      const entityChildren = await this.$getItem('entityChildren')
      return entityChildren.length > 0 ? (this.haveChild = true) : (this.haveChild = false)
    },

    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },

    async handleEdit(user) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id
      const id = user.id
      try {
        let ret = await Management.readUserEntities(entityId, actionId, id)
      } catch (e) {}
      this.UPDATE_USERS_UPDATE({ open: true, user: user })
    },

    handleDelete(item) {
      this.alert.message = `Você deseja <b>deletar</b> o usuário?<br/> <b>${item.name} ${item.surname}</b> - Matrícula: <b>${item.matriculation}</b>`
      this.alert.status = true
      this.itemToDelete = item
    },

    checkUserContainsActualEntity(item) {
      let check = 0
      for (let i = 0; i < this.users.length; i++) {
        if (this.users[i].id == item.id) {
          this.users[i].entities.forEach((entity) => {
            if (entity.entity == this.idEntity) check++
          })
          return check
        }
      }
      return check
    },

    async confirmDelete() {
      this.alert.status = false
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRemove').id
      let removedUserId = [this.itemToDelete.id]
      if (this.selectedUsers.length > 1) {
        removedUserId = this.selectedUsers.map((item) => {
          return item.id
        })
        console.log(removedUserId)
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.removeUser(entityId, actionId, removedUserId)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('deleteUser')
          this.selectedUsers = []
        }
      } catch (e) {
        console.log('catch delete user', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      this.readUsers()
    },

    async confirmRemoveFromEntity() {
      this.alert2.status = false
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRemoveFromEntity').id
      let data = { id: this.itemToDelete.id, from: entityId }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.removeUserFromEntity(entityId, actionId, data)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário <b>removido</b> da entidade com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('deleteUser')
        }
      } catch (e) {
        console.log('catch delete user', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      this.readUsers()
    },

    async readPrivileges() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readPrivilege').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await Management.readPrivilege(entityId, actionId)
        if (ret.success) {
          this.roles = ret.data
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async handleImport() {
      await this.readPrivileges()
      this.$refs.usersImport.openDialog(this.roles)
    },

    //campo busca
    async handleFilter() {
      if (this.filterType !== 'none') {
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        // const actionId = actionsMap.get('userUpdate').id
        const actionId = actionsMap.get('userRead').id
        try {
          this.$store.commit('user/UPDATE_LOADING', true)
          let ret = await Management.readUsersByFilter(
            entityId,
            actionId,
            this.filterType,
            this.filterText
          )
          if (ret.success) {
            //código para filtrar apenas os usuarios q participam da entidade - não se aplica a quem tiver o privilégio: userUpdate
            if (!actionsMap.get('userUpdate')) {
              ret.data = ret.data.filter((user) => {
                let check = false
                user.entities.forEach((entity) => {
                  if (entity.entity == entityId) check = true
                })
                if (check) return user
              })
            }

            this.users = [
              ...ret.data.map((v) => {
                let count = 0
                if (v.birthday !== undefined) v.birthday = Utils.timeConverter(v.birthday)
                v.entities.forEach((entity) => {
                  if (entity.entity == entityId) v.role = entity.privileges
                  else count++
                  if (count == v.entities.length) v.role = '---'
                })
                return v
              }),
            ]

            let roles

            // exibir nome do papel

            try {
              this.$store.commit('user/UPDATE_LOADING', true)
              let ret = await Management.readPrivilege(entityId, actionId)
              if (ret.success) roles = ret.data
            } catch (e) {
              console.log(e)
            } finally {
              // this.$store.commit('user/UPDATE_LOADING', false)
            }

            this.users.forEach((user) => {
              roles.forEach((role) => {
                if (role.id == user.role) user.role = role.label
              })
            })
          }

          this.search = true
        } catch (e) {
        } finally {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.pagination.page = 1
          this.pagination.totalItems = this.users.length
        }
      }
    },

    async readUserEntity(item) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userChangePrivilege').id
      const userId = item.id
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        ret = await Management.readUserEntities(entityId, actionId, userId)
        if (ret.success) {
          return ret.data.entities
        }
      } catch (e) {
      } finally {
        // this.$store.commit('user/UPDATE_LOADING', false)
      }
      return {}
    },

    async handleChangeRole(item) {
      this.userToEdit = item

      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      this.fatherEntity = routedEntity.name

      // papel de quem acessa e tenta mudar o privilégio de outro usuário
      const yourRoleLength = routedEntity.privileges.actions.length

      //pega o papel do usuario selecionado dentro da entidade
      let selectedUser = await this.readUserEntity(item)

      let actualEntity = selectedUser.filter((entities) => {
        return entities.entity.id == entityId
      })

      // método readPrivileges, busca todos papeis da entidade e salva em this.roles
      await this.readPrivileges()

      this.userNotFound = false
      this.changeRoleDenied = false

      // checa se usuario pertence a entidade
      if (actualEntity.length == 0) {
        // caso ele não pertença encerra o método aqui
        this.$store.commit('user/UPDATE_LOADING', false)
        this.userNotFound = true
        this.userChangeRoleDialog = true
        return
      }

      //fim checa se usuário pertence a entidade

      this.roleInActualEntity = actualEntity[0].privileges

      //verifica se quem tenta alterar o papel do usuário tem um papel inferior e não permite alterar

      this.roles.forEach((role) => {
        if (role.actions.length >= yourRoleLength && role.id == this.roleInActualEntity.id) {
          this.changeRoleDenied = true
          this.availableRolesToChange = this.roles.filter((role) => {
            return role.id == this.roleInActualEntity.id
          })
          this.userChangeRoleDialog = true
        }
      })

      if (this.changeRoleDenied) return

      // fim verificação se tem papel inferior

      this.availableRolesToChange = this.roles.filter((role) => {
        return role.actions.length <= yourRoleLength
      })

      this.userChangeRoleDialog = true
    },

    async userChangeRoleDone() {
      await this.readUsers()
      this.$store.commit('user/UPDATE_ALERT', {
        status: true,
        message: 'Papel do usuário <b>alterado</b> com sucesso!',
        icon: 'mdi-check-circle',
        color: 'green',
      })
      this.userChangeRoleDialog = false
      this.selectedUsers = []
    },

    async userChangeRoleFailed() {
      await this.readUsers()
      this.$store.commit('user/UPDATE_ALERT', {
        status: true,
        message: 'Não foi possível <b>alterar</b> o papel do usuário!',
        icon: 'mdi-close-circle',
        color: 'red',
      })
      this.userChangeRoleDialog = false
    },

    async updatedHimself() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await User.readUserEntities()
        await this.$setItem('rootEntities', ret.data)
        this.$store.commit('user/UPDATE_ROOT_ENTITIES', ret.data)

        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id

        let refreshEntity = ret.data.filter((entity) => {
          return entity.id == entityId
        })

        await this.$setItem('routedEntity', refreshEntity[0])

        //checa o que usuario pode fazer novamente
        await this.userCheckPrivileges('userCanEdit', 'userUpdate')
        await this.userCheckPrivileges('userCanChangeRole', 'userChangePrivilege')
        await this.userCheckPrivileges('userCanChangePrivilege', 'userAddOnEntity')
        await this.userCheckPrivileges('userCanDelete', 'userRemoveFromEntity')
        await this.userCheckPrivileges('userCanCreate', 'userCreate')
        await this.userCheckPrivileges('userCanImport', 'usersImport')

        await this.readUsers()
        this.$store.commit('user/UPDATE_HIMSELF_ROLE', true)
      } catch (e) {
        console.log('e', e)
      }
    },

    async handleManage(item) {
      this.userToEdit = item
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userUpdate').id
      const userId = item.id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readUserEntities(entityId, actionId, userId)
        console.log('readUsersEntities', ret.data)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.UPDATE_USERS_MANAGE({
            open: true,
            entities: ret.data,
            id: userId,
          })
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.uploadInput {
  display: none;
}
.v-pagination__item {
  margin: 4px !important;
}
.usersTable > .v-icon:hover {
  color: #ffc107 !important;
}

.usersTable > .v-icon {
  margin-right: 8px;
}

.navUsersOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.toolBar > .v-btn:hover{
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.toolBar {
  padding-top: 15px;
  padding-left: 17px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  flex-wrap: wrap;
  gap: 5px
}
</style>
